<cfsetting enablecfoutputonly="yes">
<cfif ThisTag.ExecutionMode IS "start">

	<cfsilent>
	
	<!--- 
	
		CF_AVERYRTF.CFM Version 1.2: Generate RTF output for any printable Avery Label

		Author: Brian Ghidinelli <brian@vfive.com>
		Company: vFive (http://www.vfive.com)
		
		$Id: cf_averyrtf.cfm,v 1.17 2001/11/28 18:29:05 brian Exp $

		CF_AVERYRTF is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.
		
		CF_AVERYRTF is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with CF_AVERYRTF; if not, write to the Free Software
		Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
		
		Contributions: 
			Don Johnson <don@livelihood.com>: 
				USPS RTF BarCode trick  {\*\fldinst { BARCODE }}
				Architectural ideas, review, and suggestions
				cf_averyline concept and suggestion
				Landscape mode code (not currently implemented) 
				cf_averyselect.cfm contribution
				Encouragement and testing. :)
				
			Nathan Dintenfass <nathan@changemedia.com> & Raymond Cambden <jedimaster@macromedia.com>: 
				Identifying and working around bug in ColdFusion 5 UDF+Custom Tag pairs
	
			Dan LeGate <dan@legeek.com>:
				Original concept back in early 2000.  Skimming Dan's code and reading the RTF spec
				made us @ vFive realize that a very robust parser and generator were possible.

	--->

	<!--- labeltype to be used (defaults to 5160/8160) : This is a string, not numeric (handles 5160 and 3261L and 12-294) --->
	<!--- tag parameters to be passed by external use (should be included in a VTM) --->
	<cfparam name="Attributes.labeltype" default="5160" type="string">

	<!--- font face to be used --->
	<cfparam name="Attributes.fontface" default="Arial" type="string">
	<!--- font size to be used (in points) --->
	<cfparam name="Attributes.fontsize" default="12" type="numeric">
	<!--- title of the label (stored in the header) --->
	<cfparam name="Attributes.labeltitle" default="Avery Labels Generated by CF_AVERYRTF">
	<!--- indent information --->
	<cfparam name="Attributes.leftindent" default="">
	<cfparam name="Attributes.rightindent" default="">
	<!--- alignment information, allowed: left, right, center, bottom, top, justified --->
	<cfparam name="Attributes.aligntext" default="left" type="string">
	<cfparam name="Attributes.aligndefault" default="left" type="string">
	<cfparam name="Attributes.alignvertical" default="center" type="string">
	<!--- silly border type (can be: s | th | sh | db | dot | dash | hair | none | wavy | th | emboss) --->
	<cfparam name="Attributes.border" default="none">
	<!--- barcode related (barPos = top | bottom) --->
	<cfparam name="Attributes.barPos" default="bottom" type="string">
	<!--- starting label position (on sheet of labels) --->
	<cfparam name="Attributes.startpos" default="1" type="numeric">
	<!--- the view % that the reader will open at (in Word, WordPad, etc) --->
	<cfparam name="Attributes.viewscale" default="100" type="numeric">
	<!--- should this output be in portrait or landscape mode? --->
	<cfparam name="Attributes.landscape" default="FALSE" type="boolean">
	<!--- batch-oriented variable (only if outputFile is NEQ "" will we assume we are in batch mode) --->
	<cfparam name="Attributes.outputFile" default="" type="string">
	<!--- allow tag to update itself? (UNDOCUMENTED IN VTM) --->
	<cfparam name="Attributes.autoUpdate" default="FALSE" type="boolean">
	<!--- labeltype file (FOR INTERNAL TAG USE) --->
	<cfparam name="Attributes.labeldefinition" default="#ExpandPath(".")#/labeltype.wddx" type="string">
	<!--- debug mode? (FOR INTERNAL TAG USE) --->
	<cfparam name="Attributes.debug" default="FALSE" type="boolean">
	
	<!--- load up label types (local file, remote datasource, etc?) --->
	<cfif FileExists(Attributes.labeldefinition)>
		<cffile action="read" file="#Attributes.labeldefinition#" variable="inXML">
	<cfelse>
		<!--- uh-oh, file isn't found.  let's try to fetch it from remote source (and cross fingers) --->
		<cfparam name="CGI.server_name" default="unknown">
		<cftry>
			<!--- retrieve it from the last known URL (most recent is always in wddxLabel["vchUpdateURL"]) --->
			<cfhttp url="http://www.vfive.com/rtf/update.cfm?server=#CGI.SERVER_NAME#&os=#URLEncodedFormat(SERVER.os.name)#:#URLEncodedFormat(SERVER.os.version)#:#URLEncodedFormat(SERVER.ColdFusion.ProductVersion)#" method="GET">
			<!--- should receive a WDDX packet back we can save out and use --->
			<cffile action="write" file="#Attributes.labeldefinition#" output="#CFHTTP.FileContent#">
			<!--- make data available to tag --->
			<cfset inXML = CFHTTP.FileContent>
			
			<!--- this attempt failed, meaning we aren't going to have label descriptors --->
			<cfcatch type="any">
				<cfabort showerror="Unable to load, retrieve and/or write the label description file (#Attributes.labeldefinition#).  Fatal error.<br><br> #CFCATCH.message#">
			</cfcatch>
		</cftry>
	</cfif>

	<!--- one way or another, we've got a label descriptor file - deserialize it --->	
	<cfwddx action="wddx2cfml" input="#inXML#" output="wddxLabel">
	
	<!--- update ourselves via the web and the file is sufficiently old and we're allowed to (we don't by default) --->
	<cfif Attributes.autoUpdate AND DateDiff("M", wddxLabel.dteLastUpdate, now()) GTE 3>
		<!-- the datafile is older than 3 months, it is probably out of date or at least could use an updating... --->
		<cfparam name="CGI.server_name" default="unknown">
		<cftry>
			<!--- retrieve it from the last known URL (most recent is always in wddxLabel["vchUpdateURL"]) --->
			<cfhttp url="#wddxLabel.vchUpdateURL#?server=#CGI.SERVER_NAME#&os=#URLEncodedFormat(SERVER.os.name)#:#URLEncodedFormat(SERVER.os.version)#:#URLEncodedFormat(SERVER.ColdFusion.ProductVersion)#" method="GET">
			<!--- should receive a WDDX packet back we can save out and use --->
			<cffile action="write" file="#Attributes.labeldefinition#" output="#CFHTTP.FileContent#">
			<!--- make updated data immediately available to tag --->
			<cfset inXML = CFHTTP.FileContent>
			
			<!--- this attempt failed, but it isn't fatal since we already have a label description file --->
			<cfcatch type="any">
				<!--- non-fatal error no output at this point (between cfsilents...) --->
			</cfcatch>
		</cftry>
	</cfif>

	<!-- make sure this label exists in the WDDX structure --->
	<cfif NOT StructKeyExists(wddxLabel, Attributes.labeltype)>
		<cfabort showerror="The labeltype you specified does not exist.  Please check LABELS for supported label types or right-click the tag in CFStudio or HomeSite to access supported label types.">	
	</cfif>
	
	<!--- Bring in values and massage user-supplied values to RTF-compliant values --->
	<cfscript>
		// init label holding scope
		request.rtflabels = structNew();

		// copy values into request.rtfLabels (optionally look for a label alias with IsSimpleValue())
		if (IsSimpleValue(wddxLabel[Attributes.labeltype]))
		{
			request.rtfLabels = wddxLabel["#wddxLabel[Attributes.labeltype]#"];
		}
		else
		{
			request.rtfLabels = wddxLabel[Attributes.labeltype];
		}
		
		
		// USER INTERFACE :: CONVERT HUMAN-READABLE PARAMETERS TO RTF-PARSEABLE PARAMETERS
		// setup structure of align values
		request.rtfAlign = structNew();
			request.rtfAlign.left = 'l';
			request.rtfAlign.right = 'r';
			request.rtfAlign.top = 't';
			request.rtfAlign.bottom = 'b';
			request.rtfAlign.center = 'c';
			request.rtfAlign.justify = 'i';
		// setup structure of borders
		request.rtfBorder = structNew();
			request.rtfBorder.s = 'brdrs';
			request.rtfBorder.thickline = 'brdrth';
			request.rtfBorder.sh = 'brdrsh';
			request.rtfBorder.db = 'brdrdb';
			request.rtfBorder.dottedline = 'brdrdot';
			request.rtfBorder.dashline = 'brdrdash';
			request.rtfBorder.hairline = 'brdrhair';
			request.rtfBorder.none = 'brdrnone';
			request.rtfBorder.wavyline = 'brdrwavy';
			request.rtfBorder.emboss = 'brdremboss';
		// setup structure of fonts allowed
		request.rtfFontFace = structNew();
			request.rtfFontFace["arial"] = 0;
			request.rtfFontFace["helvetica"] = 1;
			request.rtfFontFace["impact"] = 2;
			request.rtfFontFace["times new roman"] = 3;
			// extend: request.rtfFontFace[""] = ;
			

		// copy in the pertinent parameters passed by user
			// select font from available faces
			request.rtfLabels.defaultfontface = request.rtfFontFace[Attributes.fontface];
			// scale half-points up to full points
			request.rtfLabels.defaultfontsize = Attributes.fontsize * 2;
			// set label title value
			request.rtfLabels.labeltitle = Attributes.labeltitle;
			// left indent forced numeric and integer
			if (len(trim(Attributes.leftindent)))
			{
				request.rtfLabels.li = int(val(Attributes.leftindent));
			}
			// right indent forced numeric and integer
			if (len(trim(Attributes.rightindent)))
			{
				request.rtfLabels.ri = int(val(Attributes.rightindent));
			}
			// setup alignment and border type
			request.rtfLabels.textalign = request.rtfAlign[Attributes.aligntext];
			request.rtfLabels.defaultalign = request.rtfAlign[Attributes.aligndefault];
			request.rtfLabels.verticalalign = request.rtfAlign[Attributes.alignvertical];
			request.rtfLabels.bordertype = request.rtfBorder[Attributes.border];
			// setup viewscale
			request.rtfLabels.viewScale = Attributes.viewScale;

			// Holding here until a later version to support Portrait v. Landscape modes
			if (Attributes.landscape)
			{
				temp_twips = request.rtfLabels.paperw;
				request.rtfLabels.paperw = request.rtfLabels.paperh;
				request.rtfLabels.paperh = temp_twips;
			}
	</cfscript>

	</cfsilent>
	
	<!--- Make sure a closing tag exists in calling template or throw error --->
	<cfif NOT ThisTag.HasEndTag>
		<cfabort showError="You need to supply a closing &lt;/cf_cf_averyrtf&gt; tag.">
	</cfif>
	
</cfif>


<cfif ThisTag.ExecutionMode IS "end">

	<cfsilent>
	
		<!--- Protect against no sub-tags --->
		<cfparam name="ThisTag.AssocAttribs" default="#arrayNew(1)#">
		<!--- user supplied no data, that doesn't work --->
		<cfif NOT ArrayLen(ThisTag.AssocAttribs)>
			<cfabort showerror="No data was supplied.  Please consult the documentation for how to supply data to CF_AVERYRTF.">
		</cfif>

		<!--- begin the work --->	
		<cfscript>
	
			// create holding struct
			strCell = structNew();
			strCell.zipcode = '';
			strCell.barpos = 'bottom';
			strCell.stripBlankLines = 'TRUE';
			// create single element array of lines for an empty cell
			strCell.arrCell = arrayNew(1);
			// create dummy cell if needed for increasing start position or adding trailing cells 
			strLine = structNew();
				strLine.content = '';
				strLine.f = request.rtfLabels.defaultfontface;
				strLine.fs = request.rtfLabels.defaultfontsize;
				strLine.bold = 'FALSE';
				
			// copy default struct into array pos 1
			strCell.arrCell[1] = strLine;
			
			// ADD START CELLS
			// identify and add any necessary starting cells to start at position other than 1 (for mid-sheet starts)
			for (ii = 1; ii LTE Attributes.startPos - 1; ii = ii + 1)
			{
				arrayPrepend(ThisTag.AssocAttribs, strCell);
			}
	
			// ADD TRAILING CELLS
			// identify any necessary trailing cells to even out the columns and properly close the RTF 
			rowsToAdd = request.rtfLabels.columns - (arrayLen(ThisTag.AssocAttribs) MOD request.rtfLabels.columns);
	
			for (ii = 1; ii LTE rowsToAdd; ii = ii + 1)
			{
				arrayAppend(ThisTag.AssocAttribs, strCell);
			}

			// START PERFORMANCE BOOSTERS 
				// performance booster: save all cell closers as a block, this prevents us from list looping multiple times
				cellCloser = "";
				for (jj = 1; jj LTE listLen(request.rtfLabels.cellx); jj = jj + 1)
				{
					cellCloser = cellCloser & "\clvertal#request.rtfLabels.verticalalign#\clbrdrt\#request.rtfLabels.bordertype# \clbrdrl\#request.rtfLabels.bordertype# \clbrdrb\#request.rtfLabels.bordertype# \clbrdrr\#request.rtfLabels.bordertype# \cellx#listGetAt(request.rtfLabels.cellx, jj)# ";
				}
			
				// performance booster: save entire spacer row (never changes) as a single block to prevent looping/concatenation
				spacerRow = "\trowd \trrh#request.rtfLabels.trrhspacer#\trkeep ";
				spacerRow = spacerRow & cellCloser;
				spacerRow = spacerRow & " \pard\plain \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\faauto \f#request.rtfLabels.defaultfontface#\fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface#\lang1033\langfe1033 { ";
				for (jj = 1; jj LTE listLen(request.rtfLabels.cellx); jj = jj + 1)
				{
					spacerRow = spacerRow & "\cell ";
				}
				spacerRow = spacerRow &	"}\pard\plain \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\aspalpha\aspnum\faauto\adjustright \fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface#\lang1033\langfe1033 {\trowd \trrh#request.rtfLabels.trrhspacer#\trkeep ";
				spacerRow = spacerRow & cellCloser & " \row}";
			
				// performance booster: create cell boundary string to avoid looping over in every cell
				cellBoundary = "";
				for (jj = 1; jj LTE listLen(request.rtfLabels.cellx); jj = jj + 1)
				{
					cellBoundary = cellBoundary & " \cellx#listGetAt(request.rtfLabels.cellx, jj)#";
				}
			// END PERFORMANCE BOOSTERS

		</cfscript>
	
	</cfsilent>

	<!--- New ColdFusion 5 function that replaces CF_VARIABLE functionality to save ThisTag.GeneratedContent (huge increase in speed!) --->
	<cfsavecontent variable="ThisTag.GeneratedRTF">
	<cfscript>
	// open RTF document with header information
	writeOutput("{\rtf1\ansi\ansicpg1252\uc1 \deff0\deflang1033\deflangfe1033{\fonttbl{\f0\fswiss Arial;}{\f1\fswiss Helvetica;}{\f2\fswiss Impact;}{\f3\froman Times New Roman;}}");
	writeOutput("{\colortbl;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;\red255\green0\blue255;\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;\red255\green255\blue255;}");
	writeOutput("{\info{\title VFIVE Label Generator (#request.rtfLabels.labeltitle# Output)}{\author cf_averyRTF $Revision: 1.17 $}{\operator cf_averyRTF resides at http://rtf.vfive.com}{\*\company VFIVE (http://www.vfive.com)}{\creatim\yr#Year(now())#\mo#Month(now())#\dy#Day(now())#\hr#Hour(now())#\min#Minute(now())#}{\version1}{\edmins0}{\nofpages1}{\nofwords0}{\nofchars0}{\nofcharsws0}{\vern1000}}\paperw#request.rtfLabels.paperw#\paperh#request.rtfLabels.paperh#\margl#request.rtfLabels.margl#\margr#request.rtfLabels.margr#\margt#request.rtfLabels.margt#\margb#request.rtfLabels.margb#");
	if (Attributes.landscape)
	{
		writeOutput("\landscape");	
	}
	writeOutput("\gutter#request.rtfLabels.gutter# \widowctrl\ftnbj\aenddoc\noxlattoyen\expshrtn\noultrlspc\dntblnsbdb\nospaceforul\horzdoc \jexpand\viewkind1\viewscale#request.rtfLabels.viewscale#\nolnhtadjtbl \fet0\sectd \linex#request.rtfLabels.linex#\sectdefaultcl");
	
	// loop over each row in the dataset
	for (ii = 1; ii LTE arrayLen(thisTag.assocAttribs); ii = ii + 1)
	{
	
		// if this is the first cell of a row, create the row (like <tr>)
		if (NOT ((ii + request.rtfLabels.columns - 1) MOD request.rtfLabels.columns))
		{
			// output the <tr>-like row start, cellBoundary
			writeOutput("\trowd \trrh#request.rtfLabels.trrhcell#\trkeep" & cellBoundary);
			
			// output row setup (align, indent, etc)
			writeOutput(" \pard\plain \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\faauto \f#request.rtfLabels.defaultfontface#\fs20\lang1033\langfe1033");
		}
	
		// blank line for readability
		writeOutput("#chr(13)##chr(10)#");
		
		// output each individual cell header (like <td>)
		writeOutput("{\#request.rtfLabels.bold#\fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface# ");
		
		// output barcode on top if appropriate
		if (len(trim(thisTag.assocAttribs[ii].zipCode)) AND thisTag.assocAttribs[ii].barPos EQ "top")
		{
			writeOutput("{\field\flddirty{\*\fldinst { BARCODE }{\lang1024\langfe1024\noproof #ThisTag.AssocAttribs[ii].zipcode#}{\\u  }}{\fldrslt }}\par");
		}
	
		
		// loop over the lines of content in this cell
		for (jj = 1; jj LTE arrayLen(ThisTag.AssocAttribs[ii].arrCell); jj = jj + 1)
		{

			// content to be displayed?
			if (len(trim(thisTag.assocAttribs[ii].arrCell[jj].content)) OR NOT thisTag.assocAttribs[ii].stripBlankLines)
			{
				// are we bolding this line of content?
				if (thisTag.assocAttribs[ii].arrCell[jj].bold)
				{
					writeOutput("\b");
				}
				else
				{
					writeOutput("\b0");
				}
	
				// include blank line to break up actual file a bit before outputing cell's content
				writeOutput("#chr(13)##chr(10)#");
				writeOutput("\fs#ThisTag.AssocAttribs[ii].arrCell[jj].fs#\f#ThisTag.AssocAttribs[ii].arrCell[jj].f# #ThisTag.AssocAttribs[ii].arrCell[jj].content#");
	
				if (jj LT arrayLen(ThisTag.AssocAttribs[ii].arrCell))
				{
					writeOutput("\par");
				}
			}
		}
		
		// close out cell (like a </td>)
		writeOutput("}{\fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface# ");
		
		// output barcode on bottom if appropriate
		if (len(trim(thisTag.assocAttribs[ii].zipCode)) AND thisTag.assocAttribs[ii].barPos EQ "bottom")
		{
			writeOutput(" {\field\flddirty{\*\fldinst { BARCODE }{\lang1024\langfe1024\noproof #ThisTag.AssocAttribs[ii].zipcode#}{\\u  }}{\fldrslt }}");
		}
	
		// prepare to close this cell </td>
		writeOutput("\cell } ");
	
		// close this cell out like a </td>
		if (ii MOD request.rtfLabels.columns)
		{
			writeOutput(" \pard \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\faauto {\cell }");
		}
		else
		{
			writeOutput("\pard\plain \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\aspalpha\aspnum\faauto\adjustright \fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface#\lang1033\langfe1033");
		}

		// if this is the last cell of a row, end it (like a </tr>) --->
		if (NOT (ii MOD request.rtfLabels.columns))
		{
			// start close: output code + cellCloser + " \row }"
			writeOutput("\pard\plain \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\intbl\aspalpha\aspnum\faauto\adjustright \fs#request.rtfLabels.defaultfontsize#\f#request.rtfLabels.defaultfontface#\lang1033\langfe1033 {\trowd \trrh#request.rtfLabels.trrhcell#\trkeep " & cellCloser & " \row }#chr(13)##chr(10)#");

			// add an extra spacer row?
			if (request.rtfLabels.useSpacer)
			{

				// output complete spacerRow as defined above			
				writeOutput(spacerRow);

			}
		}		
	
	// end of outer for loop
	}
	
	// close out document
	writeOutput("\pard \q#request.rtfLabels.textalign# \li#request.rtfLabels.li#\ri#request.rtfLabels.ri#\widctlpar\aspalpha\aspnum\faauto\adjustright { \par }{ \par }}");
	</cfscript>
	</cfsavecontent>

	<!--- check for batch mode and output to disk or output to browser--->
	<cfif len(trim(Attributes.outputFile))>
	
		<!--- write output to file --->
		<cftry>
			<cffile action="write" file="#Attributes.outputFile#" output="#ThisTag.GeneratedRTF#" mode="664">
	
			<!--- zero-out GeneratedContent for controlling screen display --->
			<cfset ThisTag.GeneratedContent = "">
		
			<!--- inform user the process is done --->
			<cfoutput>#arrayLen(ThisTag.AssocAttribs)# Labels (#len(ThisTag.GeneratedRTF)# characters) written to #Attributes.outputFile#</cfoutput>

			<!--- if in debug mode, CFDUMP available labeltypes and ThisTag.AssocAttribs --->
			<cfif Attributes.debug>
				<!--- output mailing labels --->
				<cfdump var="#ThisTag.AssocAttribs#">
				<!--- output label types --->
				<cfdump var="#wddxLabel#">
			</cfif>
			
			<!--- had an error writing out the results --->
			<cfcatch type="any">
				<cfabort showerror="Error trying to write output to #Attributes.outputFile#.  Please check permissions and try again.">
			</cfcatch>
		</cftry>
	
	<cfelse>
	
		<!--- if in debug mode, CFDUMP available labeltypes and ThisTag.AssocAttribs --->
		<cfif Attributes.debug>

			<!--- output mailing labels --->
			<cfdump var="#ThisTag.AssocAttribs#">
			<!--- output label types --->
			<cfdump var="#wddxLabel#">

		<cfelse>

			<!--- setup the content type output if we're not in batch and debug mode  --->
			<cfheader name="Content-Disposition" value="inline; filename=labels.rtf">
			<cfcontent type="application/rtf" reset="yes">

		</cfif>

		<!--- output to client (thus, opening the RTF editor or prompting user to save the file) --->
		<cfoutput>#ThisTag.GeneratedRTF#</cfoutput>

	</cfif>


</cfif>


<cfsetting enablecfoutputonly="no">