<!--- 	cf_averyselect.cfm 
		Contributed by Don Johnson <don@livelihood.com> 
		Created: 11/27/2001 

		Tag is used to create a select drop down box for choosing which 
		kind of label output is desired.  Accepts an optional parameter
		"fieldname" for defining the name of the <select> field.
		
		This tag needs to be placed in the same directory as the labeltype.wddx
		file distributed with cf_averyrtf.  Optionally, you could modify the
		<cffile> command to point at a different location.
--->

<!--- default to a fieldname of 'labelType' --->
<cfparam name="Attributes.fieldname" default="labelType" type="string">

<!--- get label definitions from default WDDX file --->
<cfset labelDefinition = "#ExpandPath(".")#/labeltype.wddx">
<cfif FileExists(labelDefinition)>
	<cffile action="read" file="#labeldefinition#" variable="labelWDDX">
<cfelse>
	<cfabort showerror="No Avery label definitions found for tag &lt;cf_averySelectList&gt;">
</cfif>

<!--- expand into CF struct --->
<cfwddx action="WDDX2CFML" input="#labelWDDX#" output="labelStruct">

<!--- walk through keys, skipping those for internal use only --->
<cfoutput>
	<select name="#Attributes.fieldname#">
	<cfloop list="#StructKeyList(labelStruct)#" index="key">
		<cfif (key NEQ "VCHUPDATEURL") and (key NEQ "DTELASTUPDATE")>
		<option value="#key#">#key#</option>
		</cfif>
	</cfloop>
	</select>
</cfoutput>

